package hatelace;

import hatelace.instructions.*;

public class Main {
    public static void main(String[] args) {
        System.out.println("Starting...");

        Memory memory = new IntMemory(64); // 64 words of memory
        Computer computer = new Computer(memory);

        Address n = new Address(0), fac = new Address(1);

        Program program = new Program(new Instruction[] {
            new Copy(new IntWord(5), n),
            new Copy(new IntWord(1), fac),
            new JumpEq(6, n, new IntWord(1)),
            new Mul(fac, n, fac),
            new Add(n, new IntWord(-1), n),
            new Jump(2),
            new Print(fac),
            new Halt()
        });
        computer.load(program);
        computer.run();
        memory.dump();

        // Print the program
        System.out.println("Program:");
        for (Instruction instruction : program.getInstructions()) {
            System.out.println(instruction);
        }

        System.out.println("Completed");
    }
}
