package hatelace.instructions;

import hatelace.*;

public class JumpEq extends Instruction {
    private int index;
    private Address address;
    private Word value;

    public JumpEq(int index, Address address, Word value) {
        this.index = index;
        this.address = address;
        this.value = value;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        if (this.value.equals(memory.read(this.address))) {
            PC.setPC(this.index);
        } else {
            PC.incPC();
        }
    }

    protected String opcode() {
        return "jumpeq";
    }

    protected Object[] operands() {
        return new Object[] {this.index, this.address, this.value};
    }
}
