package hatelace.instructions;

import hatelace.*;

public class Mul extends Instruction {
    private Address op1;
    private Address op2;
    private Address dest;

    public Mul(Address op1, Address op2, Address dest) {
        this.op1 = op1;
        this.op2 = op2;
        this.dest = dest;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        memory.write(this.dest, memory.read(this.op1).multiply(memory.read(this.op2)));
        PC.incPC();
    }

    protected String opcode() {
        return "mul";
    }

    protected Object[] operands() {
        return new Object[] {this.op1, this.op2, this.dest};
    }
}
