package hatelace.instructions;

import hatelace.*;

public class Print extends Instruction {
    private Address address;

    public Print(Address address) {
        this.address = address;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        System.out.println(memory.read(this.address));
        PC.incPC();
    }

    protected String opcode() {
        return "print";
    }

    protected Object[] operands() {
        return new Object[] {this.address};
   }
}
